/* Copyright (c) 2023 Renmin University of China
RMDB is licensed under Mulan PSL v2.
You can use this software according to the terms and conditions of the Mulan PSL v2.
You may obtain a copy of Mulan PSL v2 at:
        http://license.coscl.org.cn/MulanPSL2
THIS SOFTWARE IS PROVIDED ON AN "AS IS" BASIS, WITHOUT WARRANTIES OF ANY KIND,
EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO NON-INFRINGEMENT,
MERCHANTABILITY OR FIT FOR A PARTICULAR PURPOSE.
See the Mulan PSL v2 for more details. */

#include "ix_scan.h"

#include "common/config.h"
#include "storage/buffer_pool_manager.h"
#include "storage/page.h"

/**
 * @brief
 * @todo 加上读锁（需要使用缓冲池得到page）
 */
void IxScan::next() {
  // increment slot no
  iid_.slot_no++;

  // 如果等于了end_ 就不要再继续修改了。不然会出大问题。
  if (iid_ != end_ && iid_.page_no != ih_->file_hdr_->last_leaf_ &&
      iid_.slot_no == ix_node_->get_size()) {
    page_id_t tmp = iid_.page_no;
    // go to next leaf
    iid_.slot_no = 0;
    iid_.page_no = ix_node_->get_next_leaf();

    bpm_->unpin_page(PageId{.fd = ih_->fd_, .page_no = tmp}, false);
    ix_node_ = ih_->fetch_node(tmp);
  }
}

Rid IxScan::rid() const { return ih_->get_rid(iid_); }